Index: trunk/Poubelle/archTOI.old/archeopsfile.cc
===================================================================
--- trunk/Poubelle/archTOI.old/archeopsfile.cc	(revision 533)
+++ trunk/Poubelle/archTOI.old/archeopsfile.cc	(revision 534)
@@ -5,5 +5,4 @@
 #define utilitaires_de_block_archeops
 #include "archeopsfile.h"
-#include "gyrohandler.h"
 
 extern "C" {
@@ -43,8 +42,4 @@
   block_type_modele         curBlock;
   block_type_modele         peekBlock;
-  
-  SSTHandler   sstHandler;
-  GyroHandler  gyroHandler;
-  GPSParser    gpsParser;
 };
 
@@ -89,5 +84,4 @@
 
 BlockSet::BlockSet(BlockSet const& x) 
-: sstHandler(x.sstHandler), gyroHandler(x.gyroHandler)
 {
   lastParam      = NULL;
@@ -255,4 +249,12 @@
   }
 }
+
+#ifdef __MWERKS__
+#pragma mark -
+#endif
+#ifdef __MWERKS__
+#pragma mark -
+#endif
+
 
 ArcheopsFile::ArcheopsFile(string const& fname) {
@@ -404,23 +406,4 @@
 }
 
-#define	 bitmot			24		// nb de bit horloge dans un mot ADC
-
-double ArcheopsFile::perEchant() { // periode d'echantillonage pour le dernier bloc reglage
-  double p,f1,f2,f3;
-  int pp;
-  if (!lastReglage()) return -1;
-  pp=lastReglage()->reglage.horloge.periode;
-  p=pp/5.;
-  f1=1000/p;f2=f1/bitmot;f3=f2*1000./(double)(lastReglage()->reglage.horloge.nb_mesures);
-  return 0.5/f3;					//  2 fois la frequence de modulation
-}
-
-double ArcheopsFile::perBlock() {  // duree (en secondes) correspondant a un bloc bolo
-  return perEchant() * (double)lastParam()->param.n_per_block*2.;
-}
-
-int ArcheopsFile::nEchBlock() {  // Nb d'echantillons dans un bloc
-  return lastParam()->param.n_per_block*2;
-}
 
 string  ArcheopsFile::blockKdName() {
@@ -448,53 +431,37 @@
 }
 
-
-block_type_param* ArcheopsFile::lastParam() {
-  return blockSet->lastParam;
-}
-block_type_journal* ArcheopsFile::lastJournal() {
-  return blockSet->lastJournal;
-}
-block_type_reglage* ArcheopsFile::lastReglage() {
-  return blockSet->lastReglage;
-}
-block_type_dilution* ArcheopsFile::lastDilution() {
-  return blockSet->lastDilution;
-}
-block_type_gps* ArcheopsFile::lastGPS() {
-  return blockSet->lastGPS;
-}
-block_type_une_periode* ArcheopsFile::lastUnePeriode() {
-  return blockSet->lastUnePeriode;
-}
-block_type_synchro_sol* ArcheopsFile::lastSynchroSol() {
-  return blockSet->lastSynchroSol;
-}
-block_type_pointage_sol* ArcheopsFile::lastPointageSol() {
-  return blockSet->lastPointageSol;
-}
-block_type_bolo* ArcheopsFile::lastBolo() {
-  return blockSet->lastBolo;
-} 
-block_type_bolo* ArcheopsFile::llastBolo() {
-  return blockSet->llastBolo;
-} 
-block_type_gyro* ArcheopsFile::lastGyro() {
-  return blockSet->lastGyro;
-}
-block_type_sst* ArcheopsFile::lastSST() {
-  return blockSet->lastSST;
-}
-block_type_bolo_comprime* ArcheopsFile::lastBoloComp() {
-  return blockSet->lastBoloComp;
-} 
-block_type_gyro_comprime* ArcheopsFile::lastGyroComp() {
-  return blockSet->lastGyroComp;
-}
-block_type_sst_comprime* ArcheopsFile::lastSSTComp() {
-  return blockSet->lastSSTComp;
-}
-
 void ArcheopsFile::forceBlock(block_type_modele* blk) {
   blockSet->setBloc(*blk);
+}
+
+long ArcheopsFile::searchNextBlock(long pos) {
+  static char* buffer = 0;
+  static int4  debswp = debut_block_mesure;
+  static int4  longmax = taille_maxi_block_archeops*20; 
+  if (!buffer) {
+    buffer = new char[longmax];
+#ifdef SWAP
+    bswap4(&debswp);
+#endif
+  }
+  long read = longmax;
+  while (read == longmax) {
+    fseek(f,pos,SEEK_SET);
+    read = fread(buffer,1,longmax,f);
+    //if (read<taille_maxi_block_archeops*2) return -1; 
+    // EA 150999 changed i+=4 to i++ -> unaligned, but can lose bytes in flight recorder
+#ifndef __DECCXX
+#define __unaligned 
+#endif
+     for (long i=4; i<read; i++) {
+      if (*(__unaligned int4*)(buffer+i) == debswp) {
+        cout << "trying to skip " << i << " bytes to pos="<<pos+i << endl;
+	    return pos+i;
+      }
+    }
+    pos += read;
+  }
+  cout << "cannot find block start" << endl;
+  return -1;
 }
 
@@ -531,9 +498,9 @@
        memcpy(&blockSet->curBlock,&blk2,sizeof(blk2));
        curKind = block_bolo;
+       postProcessBlock();
        break;
      }
      case block_sst_comprime: {  
        blockSet->setRawBloc(blockSet->curBlock);
-       if (!blockSet->sstHandler.NeedBlocks()) break; // inutile de decompresser
        block_type_sst blk2;
        block_type_sst_comprime* blk = (block_type_sst_comprime*) &blockSet->curBlock;
@@ -566,20 +533,68 @@
        memcpy(&blockSet->curBlock,&blk2,sizeof(blk2));
        curKind = block_sst;
-       //       cout << "process " << numero_block(&blockSet->curBlock) << "\n";
-       blockSet->sstHandler.ProcessBlock((block_type_sst*)&blockSet->curBlock);
+       postProcessBlock();
        break;
      }
-     case block_sst : {
-       //       cout << "process " << numero_block(&blockSet->curBlock) << "\n";
-       blockSet->sstHandler.ProcessBlock((block_type_sst*)&blockSet->curBlock);
-     }
-     case block_gyro : {
-       blockSet->gyroHandler.ProcessBlock((block_type_gyro*)&blockSet->curBlock);
-     }
-     case block_gps : {
-       blockSet->gpsParser.ProcessBlock((block_type_gps*)&blockSet->curBlock);
-     }
-  }
-}
+// Delegation a tous les producers qui traitent des blocs bruts
+  }
+}
+
+
+
+#ifdef __MWERKS__
+#pragma mark -
+#endif
+
+block_type_param* ArcheopsFile::lastParam() {
+  return blockSet->lastParam;
+}
+block_type_journal* ArcheopsFile::lastJournal() {
+  return blockSet->lastJournal;
+}
+block_type_reglage* ArcheopsFile::lastReglage() {
+  return blockSet->lastReglage;
+}
+block_type_dilution* ArcheopsFile::lastDilution() {
+  return blockSet->lastDilution;
+}
+block_type_gps* ArcheopsFile::lastGPS() {
+  return blockSet->lastGPS;
+}
+block_type_une_periode* ArcheopsFile::lastUnePeriode() {
+  return blockSet->lastUnePeriode;
+}
+block_type_synchro_sol* ArcheopsFile::lastSynchroSol() {
+  return blockSet->lastSynchroSol;
+}
+block_type_pointage_sol* ArcheopsFile::lastPointageSol() {
+  return blockSet->lastPointageSol;
+}
+block_type_bolo* ArcheopsFile::lastBolo() {
+  return blockSet->lastBolo;
+} 
+block_type_bolo* ArcheopsFile::llastBolo() {
+  return blockSet->llastBolo;
+} 
+block_type_gyro* ArcheopsFile::lastGyro() {
+  return blockSet->lastGyro;
+}
+block_type_sst* ArcheopsFile::lastSST() {
+  return blockSet->lastSST;
+}
+block_type_bolo_comprime* ArcheopsFile::lastBoloComp() {
+  return blockSet->lastBoloComp;
+} 
+block_type_gyro_comprime* ArcheopsFile::lastGyroComp() {
+  return blockSet->lastGyroComp;
+}
+block_type_sst_comprime* ArcheopsFile::lastSSTComp() {
+  return blockSet->lastSSTComp;
+}
+
+#ifdef __MWERKS__
+#pragma mark -
+#endif
+
+
 
 void ArcheopsFile::saveCurBlock() {
@@ -680,36 +695,7 @@
 #endif
 
-long ArcheopsFile::searchNextBlock(long pos) {
-  static char* buffer = 0;
-  static int4  debswp = debut_block_mesure;
-  static int4  longmax = taille_maxi_block_archeops*20; 
-  if (!buffer) {
-    buffer = new char[longmax];
-#ifdef SWAP
-    bswap4(&debswp);
-#endif
-  }
-  size_t read = longmax;
-  while (read == longmax) {
-    fseek(f,pos,SEEK_SET);
-    read = fread(buffer,1,longmax,f);
-    //if (read<taille_maxi_block_archeops*2) return -1; 
-    // EA 150999 changed i+=4 to i++ -> unaligned, but can lose bytes in flight recorder
-#ifndef __DECCXX
-#define __unaligned 
-#endif
-     for (size_t i=4; i<read; i++) {
-      if (*(__unaligned int4*)(buffer+i) == debswp) {
-	cout << "trying to skip " << i << " bytes to pos="<<pos+i << endl;
-	return pos+i;
-      }
-    }
-    pos += read;
-  }
-  cout << "cannot find block start" << endl;
-  return -1;
-}
-
-
+#ifdef __MWERKS__
+#pragma mark -
+#endif
 
 
@@ -762,5 +748,5 @@
 }
 
-void ArcheopsFile::setUTCOffset(int UTCOffset) {
+void ArcheopsFile::setUTCOffset(double UTCOffset) {
   utcOffset = UTCOffset;
   startMJD = rawMJD - utcOffset/24.;
@@ -771,346 +757,2 @@
 }
 
-int ArcheopsFile::getBoloBlockNum() {
-  if (!lastBolo()) return -1;
-  return numero_block(lastBolo());
-}
-
-int ArcheopsFile::getBoloCompBlockNum() {
-  if (!lastBolo()) return -1;
-  return numero_block(lastBoloComp());
-}
-
-int ArcheopsFile::getReglageBlockNum() {
-  if (!lastReglage()) return -1;
-  return numero_block(lastReglage());
-}
-
-int ArcheopsFile::getDilutionBlockNum() {
-  if (!lastDilution()) return -1;
-  return numero_block(lastDilution());
-}
-
-
-int ArcheopsFile::getSSTBlockNum() {
-  if (!lastSST()) return -1;
-  return numero_block(lastSST());
-}
-
-int ArcheopsFile::getSSTCompBlockNum() {
-  if (!lastSST()) return -1;
-  return numero_block(lastSSTComp());
-}
-
-
-
-int ArcheopsFile::getGyroBlockNum() {
-  if (!lastGyro()) return -1;
-  return numero_block(lastGyro());
-}
-
-
-// GPS
-// $GPGGA,hhmmss.ss,ddmm.mmmm,n,dddmm.mmmm,e,q,ss,y.y,a.a,z,
-
-
-int ArcheopsFile::getGPSBlockNum() {
-  if (!lastGPS()) return -1;
-  return numero_block(lastGPS());
-}
-
-double ArcheopsFile::getGPSUTC() {  // en secondes depuis minuit UTC jour courant
-  if (!lastGPS()) return -9.e99;
-  return blockSet->gpsParser.getUTC();
-}
-
-double ArcheopsFile::getGPSMJD() {  // modified julian day du dernier bloc GPS, JD - 2450000
-  double t = getGPSUTC()/86400. - 0.5;
-  if (t<0) return t;
-  if (t > (startMJD - int(startMJD))) {
-    return int(startMJD) + t;
-  } else {
-    return int(startMJD) + 1. + t;
-  }
-}
-
-double ArcheopsFile::getGPSLat() {  // degres, +  = NORD
-  if (!lastGPS()) return -9.e99;
-  return blockSet->gpsParser.getLatitude();
-}
-
-
-double ArcheopsFile::getGPSLong() { // degres, +  = EST
-  if (!lastGPS()) return -9.e99;
-  return blockSet->gpsParser.getLongitude();
-}
-
-double ArcheopsFile::getGPSAlt() { // meters from sea level
-  if (!lastGPS()) return -9.e99;
-  return blockSet->gpsParser.getAltitude();
-}
-
-bool ArcheopsFile::hasGPSTime() { 
-  if (!lastGPS()) return false;
- // return blockSet->gpsParser.hasGPSTime();
-  return blockSet->gpsParser.hasTime();
-}
-
-bool ArcheopsFile::hasGPSPos() { 
-  if (!lastGPS()) return false;
-  return blockSet->gpsParser.hasPosition();
-}
-
-bool ArcheopsFile::hasGPSAlt() { 
-  if (!lastGPS()) return false;
-  return blockSet->gpsParser.hasAltitude();
-}
-
-
-// Bolo
-#define  val_DS(j,i)  (blk->data_bolo[j][i]&0x1fffff)
-
-
-double ArcheopsFile::getBoloRawMuV(int ibolo, int imesure) {    // microvolts bruts
-  block_type_bolo* blk = imesure >= 0 ? lastBolo() : llastBolo();
-  if (imesure < 0) imesure += nEchBlock();
-  block_type_reglage* reglage = lastReglage();
-  block_type_param*   param = lastParam();
-  if (!blk) return 0;
-  if (!reglage) return 0;
-  if (!param) return 0;
-
-  int s = imesure % 2 ? 1 : -1;
-    
-  return s*bolo_muV(&param->param, &reglage->reglage, val_DS(ibolo,imesure), ibolo);
-}
-
-double ArcheopsFile::getBoloRawMuVCN(int ibolo, int imesure) {    
-  // Si pas bloc comprime -> 1 bit
-  int lastbit = 1;
-  if (!(lastBoloComp() == NULL) &&
-      (numero_block(lastBoloComp()) != numero_block(lastBolo()))) {
-    unsigned int4* data = lastBoloComp()->data_bolo[ibolo];
-    // Les deux premieres valeurs sont codees directement...
-    if (imesure>=2) {
-      int iExp = (imesure-2)/4 + 1;
-      int expo = data[iExp] & 0xf;
-      lastbit = 1 << expo;
-    }
-  }
-  block_type_reglage* reglage = lastReglage();
-  block_type_param*   param = lastParam();
-  if (!reglage) return 0;
-  if (!param) return 0;
-  double noise = (
-    bolo_muV(&param->param, &reglage->reglage, lastbit, ibolo) -
-    bolo_muV(&param->param, &reglage->reglage, 0, ibolo)) /2.;
-
-  return noise; 
-}
-
-
-
-def_gains 
-
-double ArcheopsFile::getBoloMuV(int ibolo, int imesure) { // microvolts, filtre avec filtre carre
-  double y = (getBoloRawMuV(ibolo, imesure-1) + getBoloRawMuV(ibolo, imesure))/2.;
-  return y;
-}
-
-double ArcheopsFile::getBoloMuV2(int ibolo, int imesure) { // microvolts, filtre 
-  // On commence par trouver la valeur d'offset, en fittant une droite sur les soustractions
-  if (!lastBolo() || !llastBolo()) return 0;
-  //block_type_reglage* reglage = lastReglage();
-  //block_type_param*   param = lastParam();
-  //if (!reglage) return 0;
-  //if (!param) return 0;
-  double sumx=0, sumy=0, sumxy=0, sumx2=0;
-  int n=20;
-  int s = imesure % 2 ? 1 : -1;
-  for (int i=1; i<=n; i++) {
-    double x = -i;
-    double y = s*(getBoloRawMuV(ibolo, imesure-i+1) - getBoloRawMuV(ibolo, imesure-i))/2;
-    s = -s;
-    sumx += x;
-    sumy += y;
-    sumxy += x*y;
-    sumx2 += x*x;
-  }
-  double a = (sumxy/n - (sumx/n)*(sumy/n)) / (sumx2/n - (sumx/n)*(sumx/n));
-  double b = (sumy/n) - a*(sumx/n);
-  s = imesure % 2 ? 1 : -1;
-  double y = getBoloRawMuV(ibolo, imesure);
-  y = y-s*b;
-  return y;
-}
-
-/*
-double ArcheopsFile::getBoloMuV2(int ibolo, int imesure) { // microvolts, filtre 
-  // On commence par trouver la valeur d'offset, en fittant une droite sur les soustractions
-  if (!lastBolo() || !llastBolo()) return 0;
-  double sumx=0, sumy=0, sumxy=0, sumx2=0;
-  int n=20;
-  int s = (imesure-n) % 2 ? 1 : -1;
-  static double* data = NULL;
-  if (!data) data = new double[n+1];
-  for (int i=0; i<=n; i++) {
-    data[i] = getBoloRawMuV(ibolo, imesure-n+i);
-  }
-  for (int i=0; i<=n; i++) {
-    
-  }
-  for (int i=1; i<=n; i++) {
-    double x = -i;
-    double y = s*(getBoloRawMuV(ibolo, imesure-i+1) - getBoloRawMuV(ibolo, imesure-i))/2;
-    s = -s;
-    sumx += x;
-    sumy += y;
-    sumxy += x*y;
-    sumx2 += x*x;
-  }
-  double a = (sumxy/n - (sumx/n)*(sumy/n)) / (sumx2/n - (sumx/n)*(sumx/n));
-  double b = (sumy/n) - a*(sumx/n);
-  s = imesure % 2 ? 1 : -1;
-  double y = getBoloRawMuV(ibolo, imesure);
-  y = y-s*b;
-  return y;
-}
-*/
-
-
-double ArcheopsFile::getGainAmpli(int ibolo) {
-     return gain_ampli(lastReglage()->reglage.bolo[ibolo]);
-}
-
-
-double ArcheopsFile::getDACV(int ibolo) {
-  block_type_reglage* reglage = lastReglage();
-  block_type_param*   param = lastParam();
-  if (!reglage) return 0;
-  if (!param) return 0;
-  return DAC_muV(&param->param, &reglage->reglage, ibolo);
-}
-
-double ArcheopsFile::getDACI(int ibolo) {
-  block_type_reglage* reglage = lastReglage();
-  block_type_param*   param = lastParam();
-  if (!reglage) return 0;
-  if (!param) return 0;
-  return DAC_muA(&param->param, &reglage->reglage, ibolo);
-}
-
-double ArcheopsFile::getBoloMuV2T(int ibolo, int imesure) {
-  return getDACV(ibolo) - getBoloMuV2(ibolo, imesure) ;
-}
-
-double ArcheopsFile::getBoloRes(int ibolo, int imesure) {
-  double i = getDACI(ibolo); // microAmps
-  double v = getBoloMuV2T(ibolo, imesure); // microVolts
-  double r = v/i; // Ohms
-  return r;
-}
-
-double ArcheopsFile::getBoloTemp(int ibolo, int imesure) {
-  double r = getBoloRes(ibolo, imesure);
-  block_type_reglage* reglage = lastReglage();
-  block_type_param*   param = lastParam();
-  if (!reglage) return 0;
-  if (!param) return 0;
-  return bolo_temp(&param->param, &reglage->reglage, r, ibolo);
-}
-
-
-// Dilution
-
-int4 ArcheopsFile::getADCDil(int iADC) {
-  block_type_dilution* blk = lastDilution();
-  if (!blk) return 0;
-  if (iADC < 0 || iADC > 47) return 0;
-  return blk->ADC_dil[iADC];
-}
-
-int4 ArcheopsFile::getSwitchDil() {
-  block_type_dilution* blk = lastDilution();
-  if (!blk) return 0;
-  return blk->switch_dil;
-}
-
-
-// SST, gyros...
-
-void ArcheopsFile::needSSTProcessMask(int mask) {
-  blockSet->sstHandler.NeedProcess(mask);
-}
-
-long ArcheopsFile::getSSTSignal(int idiode, int imesure) {
-  return blockSet->sstHandler.getSignal(imesure, idiode);
-}
-
-long ArcheopsFile::getSSTRawSignal(int idiode, int imesure) {
-  return blockSet->sstHandler.getRawSignal(imesure, idiode);
-}
-
-double ArcheopsFile::getSSTSignalCN(int idiode, int imesure) {
-  return getSSTRawSignalCN(SSTHandler::getDiodPermut(idiode),imesure);
-}
-
-double ArcheopsFile::getSSTRawSignalCN(int ichannel, int imesure) {
-  // Si pas bloc comprime -> 0.5
-  if (lastSSTComp() == NULL) return .5;
-  if (numero_block(lastSSTComp()) != numero_block(lastSST())) return 0.5;
-  
-  // Attention, on ne transmet pas les canaux 0 et 4....
-  if (ichannel == 0 || ichannel == 4) return 0;
-  int i = ichannel - 1;
-  if (i >= 4) i--;
-  unsigned int4* data = lastSSTComp()->sst[i];
-  // Les deux premieres valeurs sont codees directement...
-  if (imesure<2) return 0.5;
-  int iExp = (imesure-2)/7 + 1;
-  int expo = data[iExp] & 0xf;
-  int noise = 1 << expo;
-  return noise/2.;
-}
-
-
-
-double ArcheopsFile::getSSTStarZ(int istar, int imesure) {
-  return blockSet->sstHandler.getStarZ(imesure+getSSTBlockNum()*nb_per_block*2, istar);
-}
-
-double ArcheopsFile::getSSTStarF(int istar, int imesure) {
-  return blockSet->sstHandler.getStarF(imesure+getSSTBlockNum()*nb_per_block*2, istar);
-}
-
-double ArcheopsFile::getSSTStarT(int istar, int imesure) {
-  return blockSet->sstHandler.getStarTime(imesure+getSSTBlockNum()*nb_per_block*2, istar);
-}
-
-int ArcheopsFile::getNumbStar(int imesure) {
-  return blockSet->sstHandler.getNumbStar(imesure+getSSTBlockNum()*nb_per_block*2);
-}
-
-long ArcheopsFile::getGyroRaw(int igyro, int imesure) {   
-  return blockSet->gyroHandler.getRawSignal(imesure, igyro);
-}
-
-double ArcheopsFile::getGyroTens(int igyro, int imesure) {   
-  return blockSet->gyroHandler.getSignal(imesure, igyro);
-}
-
-double ArcheopsFile::getGyroSpeed(int igyro, int imesure) {   
-  return blockSet->gyroHandler.getSpeed(imesure, igyro);
-}
-
-
-
-
-
-// $CHECK$ TBD
-
-
-double ArcheopsFile::getAzimut(int /*imesure*/) {return 0;}
-double ArcheopsFile::getPendDirect(int /*imesure*/) {return 0;}
-double ArcheopsFile::getPendOrth(int /*imesure*/) {return 0;}
-double ArcheopsFile::getAlphaAxis(int /*imesure*/) {return 0;}
-double ArcheopsFile::getDeltaAxis(int /*imesure*/) {return 0;}
Index: trunk/Poubelle/archTOI.old/archeopsfile.h
===================================================================
--- trunk/Poubelle/archTOI.old/archeopsfile.h	(revision 533)
+++ trunk/Poubelle/archTOI.old/archeopsfile.h	(revision 534)
@@ -9,15 +9,8 @@
 #include <stack>
 
+using namespace std;
 
-#ifndef nb_max_bolo
-#define _archeops		//  Acquisition Archeops (avec transputer) 
-#define programme
-extern "C" {
-#include "archeops.h"
-}
-#endif
-
-#include "ssthandler.h"
-#include "gpsparser.h"
+#include "ark.h"
+#include "archexc.h"
 
 enum {
@@ -50,11 +43,4 @@
 class BlockSet;
 
-class ArchExc {
-public:
-  ArchExc(string s) : msg(s) {}
-  string Msg() {return msg;}
-protected:
-  string msg;
-};
 
 class ArcheopsFile {
@@ -64,5 +50,5 @@
   virtual ~ArcheopsFile();
   
-  void setUTCOffset(int UTCOffset=2); // StartMJD : decodage a partir du nom du bloc...
+  void setUTCOffset(double UTCOffset=2); // StartMJD : decodage a partir du nom du bloc...
   double getStartMJD();
   
@@ -76,9 +62,4 @@
   string blockRawKdName();
   string filename() {return fn;}
-  
-  double perEchant(); // periode d'echantillonage pour le dernier bloc reglage
-  double perBlock();  // duree (en secondes) correspondant a un bloc bolo
-                      // utilise infos dernier bloc param et dernier bloc reglage.
-  int nEchBlock(); // Nb d'echantillons dans un bloc bolo
   
   
@@ -109,66 +90,5 @@
   
   void forceBlock(block_type_modele* blk);
-  
-  // Decodage des derniers blocs..
-  
-  // GPS
-  // On travaille en MJD = JD - 2450000.0, = 9 octobre 1995 midi UTC
-  // 1er juillet 1999 minuit UTC = JD 2451360.5,   MJD 1360.5 
-  // Ces fonctions travaillent sur le dernier bloc GPS 
-  int getGPSBlockNum();
-  bool   hasGPSTime();
-  bool   hasGPSPos();
-  bool   hasGPSAlt();
-  double getGPSUTC();  // en secondes depuis minuit UTC
-  double getGPSMJD();  // modified julian day du dernier bloc GPS, JD - 2450000
-  double getGPSLat();  // degres, +  = NORD
-  double getGPSLong(); // degres, +  = EST
-  double getGPSAlt();  // meters from sea level
     
-  // Bolo
-  int getReglageBlockNum();
-  int getBoloBlockNum();
-  int getBoloCompBlockNum();
-  double getBoloRawMuV(int ibolo, int imesure);   // donnee brute en microvolts et signe change.
-  double getBoloRawMuVCN(int ibolo, int imesure);  // bruit de compression, en microVolts
-  double getBoloMuV(int ibolo, int imesure); // microvolts, filtre avec filtre carre
-  double getBoloMuV2(int ibolo, int imesure); // microvolts, filtre +sioux
-  double getGainAmpli(int ibolo);
-  double getDACV(int ibolo); // offset en microvolt
-  double getDACI(int ibolo); // courant en microAmps
-  double getBoloMuV2T(int ibolo, int imesure); // avec soustraction dacV
-  double getBoloRes(int ibolo, int imesure); // Ohms
-  double getBoloTemp(int ibolo, int imesure); // K
-  
-  // Dilution
-  int getDilutionBlockNum();
-  int4 getADCDil(int iADC);
-  int4 getSwitchDil();
-  
-  // SST, gyros, etc
-  int getSSTBlockNum();
-  int getSSTCompBlockNum();
-  void needSSTProcessMask(int mask);
-  long getSSTRawSignal(int iDiode, int imesure);
-  long getSSTSignal(int iDiode, int imesure);
-  double getSSTRawSignalCN(int iDiode, int imesure);
-  double getSSTSignalCN(int iDiode, int imesure);
-  double getSSTStarZ(int iStar, int imesure);
-  double getSSTStarF(int iStar, int imesure);
-  double getSSTStarT(int iStar, int imesure);
-  int getNumbStar(int imesure);
-  
-  int getGyroBlockNum();
-  long getGyroRaw(int iGyro, int imesure);
-  double getGyroTens(int iGyro, int imesure);
-  double getGyroSpeed(int iGyro, int imesure);
-  
-  double getAzimut(int imesure);
-  double getPendDirect(int imesure);
-  double getPendOrth(int imesure);
-  
-  double getAlphaAxis(int imesure);
-  double getDeltaAxis(int imesure);
-  
   static double decodeMJD(string const& dateString); // sans tenir compte de TU-TLeg
     
@@ -176,5 +96,5 @@
   BlockSet*                 blockSet;
   stack<BlockSet*>          blockStack;
-  stack<size_t>             fposStack;
+  stack<long>               fposStack;
   
   void saveCurBlock();
@@ -193,5 +113,5 @@
   long                      curPos;
   long                      peekPos;
-  size_t                    fLen;
+  long                      fLen;
   FILE* f;
   string fn;
Index: trunk/Poubelle/archTOI.old/archexc.h
===================================================================
--- trunk/Poubelle/archTOI.old/archexc.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/archexc.h	(revision 534)
@@ -0,0 +1,18 @@
+// archexc.h
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#ifndef ARCHEXC_H
+#define ARCHEXC_H
+
+#include <string>
+using namespace std;
+
+class ArchExc {
+public:
+  ArchExc(string s) : msg(s) {}
+  string Msg() {return msg;}
+protected:
+  string msg;
+};
+
+#endif
Index: trunk/Poubelle/archTOI.old/archfileset.cc
===================================================================
--- trunk/Poubelle/archTOI.old/archfileset.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/archfileset.cc	(revision 534)
@@ -0,0 +1,325 @@
+// archfileset.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#include <iostream.h>
+#include <dirent.h>
+#include "archfileset.h"
+#include "archparam.h"
+#include "toiproducer.h"
+#include "toimanager.h"
+
+ArchFileSet::ArchFileSet() {
+  file = NULL;
+  
+  trigMask = block_reglage_mask | block_param_mask | TOIManager::trigMask;
+  
+  sStart   = -999999999;
+  sEnd     =  999999999;
+  mjdStart = -999999999;
+  mjdEnd   =  999999999;
+
+  initDone = false;
+  endFound = false;
+}
+
+ArchFileSet::ArchFileSet(ArchFileSet const& x) {
+  directories = x.directories;
+  filenames = x.filenames;
+  if (x.initDone && x.curFile != x.filenames.end()) curFile = filenames.find(*(x.curFile));
+
+  trigMask = x.trigMask;
+
+  sStart   = x.sStart;
+  sEnd     = x.sEnd;
+  mjdStart = x.mjdStart;
+  mjdEnd   = x.mjdEnd;
+  
+  if (x.file)
+    file = new ArcheopsFile(*x.file);
+  else 
+    file = NULL;
+      
+  initDone = x.initDone;
+  endFound = x.endFound;
+}
+
+ArchFileSet::~ArchFileSet() {
+  delete file;
+}
+
+void ArchFileSet::setSNumRange(long start, long end) {
+  sStart = start;
+  sEnd   = end;
+}
+
+void ArchFileSet::setMJDRange(double start, double end) {
+  mjdStart = start;
+  mjdEnd   = end;
+}
+
+void ArchFileSet::addFile(string fn) {
+  filenames.insert(fn);
+}
+
+void ArchFileSet::addDirectory(string fn) {
+  directories.insert(fn);
+}
+
+
+
+#ifdef __MWERKS__
+#pragma mark -
+#endif
+
+#ifdef __MWERKS__
+#define filesep ':'
+#else
+#define filesep '/'
+#endif
+
+void ArchFileSet::init() {
+  if (initDone) return;
+  initDone = true;
+  trigMask |= TOIManager::trigMask;
+  
+  // build files from directories
+  for (set<string>::iterator i = directories.begin(); i != directories.end(); i++) {
+    string directory = *i;
+    if (directory[directory.length()-1] != filesep) 
+      directory += filesep;
+      
+    DIR* dir = opendir(directory.c_str());
+    struct dirent* ent;
+    
+    while ((ent = readdir(dir)) != NULL) {
+      // si c'est un repertoire, avec un nom de jour, il faut l'explorer...
+      if (!strncmp(ent->d_name, "arch-", 5)) {
+        double mjd = ArcheopsFile::decodeMJD(ent->d_name+5) - 2./24.; // ENTIER + .5 en temps local!
+        if (mjd >= mjdStart - 1. && mjd <= mjdEnd) {
+          string direc2 = directory + ent->d_name + filesep;
+          DIR* dir2 = opendir(direc2.c_str());
+          struct dirent* ent2;
+          while ((ent2 = readdir(dir2)) != NULL) {
+            if (*ent2->d_name == 'h') {
+              double mjd2 = ArcheopsFile::decodeMJD(ent->d_name+1) - 2./24.;
+              if (mjd2 >= mjdStart - 1./24. && mjd2 <= mjdEnd) {
+                filenames.insert(direc2 + ent2->d_name);
+              }
+            }
+          }
+        }
+      } // "arch-"
+      else if (*ent->d_name == 'h') {
+        double mjd = ArcheopsFile::decodeMJD(ent->d_name+1) - 2./24.; // $CHECK$ UTCOffset
+        if (mjd >= mjdStart - 1./24. && mjd <= mjdEnd) {
+           filenames.insert(directory + ent->d_name);
+        }
+      } // "h*"
+      else  if (!strncmp(ent->d_name, "ARK", 3) || !strncmp(ent->d_name, "ark", 3)) {
+        char * sfx = ent->d_name + strlen(ent->d_name) - 4;
+        if (!strcmp(sfx, ".DAT") || !strcmp(sfx, ".dat")) {
+          filenames.insert(directory + ent->d_name);
+        }
+      }
+    } // readdir
+    closedir(dir);
+  } // iterate on dirs
+
+  scanFiles();
+  
+  if (filenames.empty()) {
+    throw ArchExc("No files in fileset");
+  }
+  
+  curFile = filenames.begin();
+  file = new ArcheopsFile((*curFile).c_str());
+  cout << "opening file " << (*curFile).c_str() << endl;
+
+  extern param_bolo  parametr;
+  block_type_param block;
+  block.param = parametr;
+  valide_block((block_type_modele*)&block, block_param, 0);
+  file->forceBlock((block_type_modele*)&block);
+
+  if (!file->lastReglage()) file->nextBlock(block_reglage_mask);
+}
+
+void ArchFileSet::scanFiles() {
+  file1stSamp.clear();
+  cout << "Scanning all files" << endl;
+  // Petite astuce pour les STL non conformes comme celles de digital
+  // qui ne supportent pas files.erase(i) suivi de i++....
+  set<string> copy = filenames;
+  for (set<string>::iterator i = copy.begin(); i != copy.end(); i++) {
+    ArcheopsFile fich((*i).c_str());
+    if (fich.nextBlock()) {
+      file1stSamp[*i] = fich.blockNum()*72; // premier numsample
+      cout << "File " << *i << " 1st sample = " << fich.blockNum()*72 << endl;
+    } else {
+      cout << "File " << *i << " unrecoverable, skipping" << endl;
+      filenames.erase(*i);
+    }
+  }
+  cout << "Scan done" << endl;
+  
+  // Et maintenant, on ne garde que ceux qui tombent dans l'intervalle...
+  copy = filenames;
+  string prev="";
+  for (set<string>::iterator i = copy.begin(); i != copy.end(); i++) {
+    double smp = file1stSamp[*i];
+    double t   = archParam.acq.tBlock0 + smp * archParam.acq.perEch/86400.;
+    if (t>mjdEnd || smp>sEnd) {  // premier echantillon apres tEnd
+     filenames.erase(*i);
+     prev = "";
+     continue;
+    }
+    if (t<mjdStart || smp<sStart) { // premier echantillon avant tStart -> on vire le precedent si existe
+      if (prev != "") {
+        filenames.erase(prev);
+      }
+    }
+    prev = *i;
+  }
+}
+
+bool ArchFileSet::nextFile() {    
+  if (filenames.empty()) {
+    return false;
+  } else {
+    if (curFile == filenames.end()) return false;
+    curFile++;
+    if (curFile == filenames.end()) return false;
+    cout << "opening file " << (*curFile).c_str() << endl;
+    ArcheopsFile* newfile = new ArcheopsFile((*curFile).c_str());
+    newfile->grabLastBlocs(*file);
+    delete file;
+    file = newfile;
+    return true;
+  }
+}
+
+bool ArchFileSet::next() {
+  if (endFound) return false;
+  if (!initDone) init();
+  while (1) {
+    long got = nextSample();
+    if (!got) {endFound=true; return false;} // end of files
+    double t = getMJD();
+    if (t < mjdStart) continue;
+    if (t > mjdEnd) {endFound=true; return false;}
+    long s = getSampleIndex();
+    if (s < sStart) continue;
+    if (s > sEnd) {endFound=true; return false;}
+    
+    // On envoie les nouvelles donnees aux producers interesses
+    for (map<TOILowLevProducer*, long>::iterator i = TOIManager::activeLLProducers.begin(); 
+         i != TOIManager::activeLLProducers.end(); i++) {
+      if (got & ((*i).second)) (*i).first->handleBlock(this);
+    }
+    
+    return true;
+  }
+}
+
+long ArchFileSet::getSampleIndex() {
+  if (!initDone) init();
+  return file->blockNum() * nb_per_block*2;
+}
+
+double ArchFileSet::getMJD() {
+  if (!initDone) init();
+  int sample = getSampleIndex();
+  return archParam.acq.SN2MJD(sample);
+}
+
+long ArchFileSet::nextSample() {
+  while (1) {
+    long got = 0;
+    if (file->nextBlock(trigMask)) {
+      got |= 1 << type_block(file->currentBlock());
+      while (file->sameBlockNumAhead()) {  // tant que meme numero de bloc, on lit
+        if (!file->nextBlock()) {          // fin de fichier ?
+          if (nextFile()) file->nextBlock(); // fichier suivant
+          else return 0;    // tout fini
+        }
+      got |= 1 << type_block(file->currentBlock());
+      }
+      return got;
+    }
+    if (!nextFile()) return 0;
+  }
+}
+
+#ifdef __MWERKS__
+#pragma mark -
+#endif
+
+block_type_param*         ArchFileSet::lastParam() {
+  if (!file) return NULL;
+  return file->lastParam();
+}
+
+block_type_journal*       ArchFileSet::lastJournal() {
+  if (!file) return NULL;
+  return file->lastJournal();
+}
+
+block_type_reglage*       ArchFileSet::lastReglage() {
+  if (!file) return NULL;
+  return file->lastReglage();
+}
+
+block_type_dilution*      ArchFileSet::lastDilution() {
+  if (!file) return NULL;
+  return file->lastDilution();
+}
+
+block_type_gps*           ArchFileSet::lastGPS() {
+  if (!file) return NULL;
+  return file->lastGPS();
+}
+
+block_type_une_periode*   ArchFileSet::lastUnePeriode() {
+  if (!file) return NULL;
+  return file->lastUnePeriode();
+}
+
+block_type_synchro_sol*   ArchFileSet::lastSynchroSol() {
+  if (!file) return NULL;
+  return file->lastSynchroSol();
+}
+
+block_type_pointage_sol*  ArchFileSet::lastPointageSol() {
+  if (!file) return NULL;
+  return file->lastPointageSol();
+}
+
+block_type_bolo*          ArchFileSet::lastBolo() {
+  if (!file) return NULL;
+  return file->lastBolo();
+} 
+  
+block_type_gyro*          ArchFileSet::lastGyro() {
+  if (!file) return NULL;
+  return file->lastGyro();
+}
+
+block_type_sst*           ArchFileSet::lastSST() {
+  if (!file) return NULL;
+  return file->lastSST();
+}
+
+block_type_bolo_comprime* ArchFileSet::lastBoloComp() {
+  if (!file) return NULL;
+  return file->lastBoloComp();
+}  
+ 
+block_type_gyro_comprime* ArchFileSet::lastGyroComp() {
+  if (!file) return NULL;
+  return file->lastGyroComp();
+}
+
+block_type_sst_comprime*  ArchFileSet::lastSSTComp() {
+  if (!file) return NULL;
+  return file->lastSSTComp();
+}
